Ruby - Bug #13390

MinGW build test-all SEGV, issue in test framework or error recovery?
03/30/2017 08:38 PM - MSP-Greg (Greg L)

Status: Closed

Priority: Normal

Assignee: nobu (Nobuyoshi Nakada)

Target version:

ruby -v: ruby 2.5.0dev (2017-03-31 trunk 58222) |Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:
[x64-mingw32] UNKNOWN

Description

Today, while building trunk (64 bit MinGW), | had a 'no output' SEGV during test-all.
I think I've had this before, but | don't recall how recently, 32 or 64, etc.
The problem is in the following test:

File 'test/ruby/test keyword.rb'", line 310

310 def test_required_keyword

311 feature7701 = '[ruby-core:51454] [Feature #7701] required keyword argument'

312 o = Object.new

313 assert_nothing_raised(SyntaxError, feature7701) do

314 eval ("def o.foo(a:) a; end", nil, "xyzzy")

315 eval ("def o.bar(a:,**b) [a, b]l; end")

316 end

317 assert_raise_with_message (ArgumentError, /missing keyword/, feature7701) {o.foo}

318 assert_raise_with_message (ArgumentError, /unknown keyword/, feature7701) {o.foo(a:0, b:1l)}
319 begin

320 o.foo(a: 0, b: 1)

321 rescue => e

322 assert_equal ('xyzzy', e.backtrace_locations|[0].path)

323 end

324 assert_equal (42, o.foo(a: 42), feature7701)

325 assert_equal ([[:keyreq, :a]], o.method(:foo) .parameters, feature7701)

326

327 bug8139 = '[ruby-core:53608] [Bug #8139] required keyword argument with rest hash'
328 assert_equal ([42, {}], o.bar(a: 42), feature7701)

329 assert_equal ([42, {c: feature7701}], o.bar(a: 42, c: feature7701), feature7701)

330 assert_equal ([ [:keyreq, :a], [:keyrest, :b]], o.method(:bar).parameters, feature7701)
331 assert_raise_with_message (ArgumentError, /missing keyword/, bug8139) {o.bar(c: bug8139)}
332 assert_raise_with_message (ArgumentError, /missing keyword/, bug8139) {o.bar}

333 end

Now, the part where it gets fun is that | originally thought the error was between lines 319-323. | moved out of the build framework,

simplified it, and things seemed okay. All errors were raised, backiraces were correct, etc.
As | tested further, here's what | found:
1. If lines 317 & 318 are commented out, the 319-323 block runs as it should, or line 322 is 'correct'.
2. If lines 317 & 318 are not commented out, line 320 must be commented out for the method to finish.

3. Otherwise, a 'no output' SEGV...

History

#1 - 03/31/2017 01:48 AM - MSP-Greg (Greg L)

Just ran the test file fifty (50) times on ruby 2.5.0dev (2017-03-29 trunk 58201) [x64-mingw32], and it ran fine (no comments required). I'll try to build

some intermediate svn's to narrow the issue to fewer commits.
https://github.com/ruby/ruby/blob/trunk/test/ruby/test_keyword.rb#L310-L333

#2 - 04/18/2017 08:41 PM - MSP-Greg (Greg L)

This patch is no longer needed as of builds around ruby 2.5.0dev (2017-04-17 trunk 58383) [x64-mingw32]. It may return when | get around to
building 2.4 and 2.3 stable branches. Please close.

#3 - 05/19/2017 06:50 AM - naruse (Yui NARUSE)
- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

#4 - 05/19/2017 06:44 PM - MSP-Greg (Greg L)

As mentioned in 13542, | have not had a failure with this for a while, even when using -j3, which is when the issue typically occurred.

Please close, as | cannot.

#5 - 05/25/2017 09:15 AM - Eregon (Benoit Daloze)

- Status changed from Assigned to Closed

Closing per OP request
https://bugs.ruby-lang.org/issues/13542
